=== debian/changelog ===
sra-sdk (2.10.9+dfsg-2) unstable; urgency=medium

  * run-unit-test: Give up for now on {abi,fastq,illumina,sff}-load.
    All four rely deeply on retired VDB functionality that would be
    too awkward to reintroduce.
  * skip_broken_loaders.patch (new): Likewise stop building or trying to
    install anything from tools/sra-load, to avoid leading users on.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 04 Feb 2021 20:38:51 -0500

sra-sdk (2.10.9+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * d/watch:
    - file standard 4
    - Use filemangle to make sure the archive will not mixed up
      with other ncbi code with same version
  * Remove default debian/gbp.conf
  * Bump versioned Build-Depends: libngs-sdk-dev (>= 2.10.9)
  * Drop patch reenable_legacy_schema_in_sra_load.patch

 -- Andreas Tille <tille@debian.org>  Mon, 18 Jan 2021 09:23:28 +0100
